Panda3D

Loading...
Searching...
No Matches
Classes | Public Member Functions | Static Public Member Functions | List of all members
MovieVideoCursor Class Reference

A MovieVideo is actually any source that provides a sequence of video frames. More...

`#include "movieVideoCursor.h"`

Inheritance diagram for MovieVideoCursor:

## Classes
class | Buffer

## Public Member Functions
bool | aborted () const
virtual void | apply_to_texture (const Buffer *buffer, Texture *t, int page)
| Stores this buffer's contents in the indicated texture.
virtual void | apply_to_texture_alpha (const Buffer *buffer, Texture *t, int page, int alpha_src)
| Copies this buffer's contents into the alpha channel of the supplied texture.
virtual void | apply_to_texture_rgb (const Buffer *buffer, Texture *t, int page)
| Copies this buffer's contents into the RGB channels of the supplied texture.
bool | can_seek () const
bool | can_seek_fast () const
virtual int | complete_pointers (TypedWritable **plist, BamReader *manager)
| Receives an array of pointers, one for each time manager->read_pointer() was called in fillin().
virtual TypeHandle | force_init_type ()
int | get_num_components () const
virtual TypeHandle | get_type () const
double | length () const
virtual | PT (Buffer) fetch_buffer()
| PT (MovieVideo) get_source() const
bool | ready () const
virtual bool | set_time (double timestamp, int loop_count)
| Updates the cursor to the indicated time.
void | setup_texture (Texture *tex) const
| Set up the specified Texture object to contain content from this movie.
int | size_x () const
int | size_y () const
bool | streaming () const
virtual void | write_datagram (BamWriter *manager, Datagram &dg)
| Writes the contents of this object to the datagram for shipping out to a Bam file.
Public Member Functions inherited from TypedWritableReferenceCount
| TypedWritableReferenceCount (const TypedWritableReferenceCount &copy)
virtual ReferenceCount * | as_reference_count ()
| Returns the pointer cast to a ReferenceCount pointer, if it is in fact of that type.
void | operator= (const TypedWritableReferenceCount &copy)
Public Member Functions inherited from TypedWritable
| TypedWritable (const TypedWritable &copy)
vector_uchar | encode_to_bam_stream () const
| Converts the TypedWritable object into a single stream of data using a BamWriter, and returns that data as a bytes object.
bool | encode_to_bam_stream (vector_uchar &data, BamWriter *writer=nullptr) const
| Converts the TypedWritable object into a single stream of data using a BamWriter, and stores that data in the indicated string.
virtual void | finalize (BamReader *manager)
| Called by the BamReader to perform any final actions needed for setting up the object after all objects have been read and all pointers have been completed.
UpdateSeq | get_bam_modified () const
| Returns the current bam_modified counter.
void | mark_bam_modified ()
| Increments the bam_modified counter, so that this object will be invalidated and retransmitted on any open bam streams.
void | operator= (const TypedWritable &copy)
virtual bool | require_fully_complete () const
| Some objects require all of their nested pointers to have been completed before the objects themselves can be completed.
virtual void | update_bam_nested (BamWriter *manager)
| Called by the BamWriter when this object has not itself been modified recently, but it should check its nested objects for updates.
Public Member Functions inherited from TypedObject
| TypedObject (const TypedObject &copy)=default
TypedObject * | as_typed_object ()
| Returns the object, upcast (if necessary) to a TypedObject pointer.
const TypedObject * | as_typed_object () const
| Returns the object, upcast (if necessary) to a TypedObject pointer.
int | get_best_parent_from_Set (const std::set< int > &) const
int | get_type_index () const
| Returns the internal index number associated with this object's TypeHandle, a unique number for each different type.
bool | is_exact_type (TypeHandle handle) const
| Returns true if the current object is the indicated type exactly.
bool | is_of_type (TypeHandle handle) const
| Returns true if the current object is or derives from the indicated type.
TypedObject & | operator= (const TypedObject &copy)=default
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)
Public Member Functions inherited from ReferenceCount
int | get_ref_count () const
WeakReferenceList * | get_weak_list () const
| Returns the WeakReferenceList associated with this ReferenceCount object.
bool | has_weak_list () const
| Returns true if this particular ReferenceCount object has a WeakReferenceList created, false otherwise.
void | local_object ()
| This function should be called, once, immediately after creating a new instance of some ReferenceCount-derived object on the stack.
void | ref () const
| Explicitly increments the reference count.
bool | ref_if_nonzero () const
| Atomically increases the reference count of this object if it is not zero.
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus.
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus.
virtual bool | unref () const
| Explicitly decrements the reference count.
bool | unref_if_one () const
| Atomically decreases the reference count of this object if it is one.
WeakReferenceList * | weak_ref ()
| Adds the indicated PointerToVoid as a weak reference to this object.
void | weak_unref ()
| Removes the indicated PointerToVoid as a weak reference to this object.

## Static Public Member Functions
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedWritableReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
static | PT (TypedWritableReferenceCount) decode_from_bam_stream(vector_uchar data
Static Public Member Functions inherited from TypedWritable
static bool | decode_raw_from_bam_stream (TypedWritable *&ptr, ReferenceCount *&ref_ptr, vector_uchar data, BamReader *reader=nullptr)
| Reads the bytes created by a previous call to encode_to_bam_stream(), and extracts the single object on those bytes.
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedObject
static TypeHandle | get_class_type ()
static void | init_type ()
| This function is declared non-inline to work around a compiler bug in g++ 2.96.
Static Public Member Functions inherited from ReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()

## Additional Inherited Members
Public Attributes inherited from TypedWritableReferenceCount
static BamReader * | reader = nullptr)
Public Attributes inherited from TypedObject
| get_type
Public Attributes inherited from ReferenceCount
| get_ref_count
| Returns the current reference count.
Static Public Attributes inherited from TypedWritable
static TypedWritable *const | Null = nullptr

## Detailed Description

A MovieVideo is actually any source that provides a sequence of video frames.

That could include an AVI file, a digital camera, or an internet TV station. A MovieVideoCursor is a handle that lets you read data sequentially from a MovieVideo.

Thread safety: each individual MovieVideoCursor must be owned and accessed by a single thread. It is OK for two different threads to open the same file at the same time, as long as they use separate MovieVideoCursor objects.

Definition at line 41 of file movieVideoCursor.h.

## Constructor & Destructor Documentation

## ◆ ~MovieVideoCursor()

MovieVideoCursor::~MovieVideoCursor | ( |  | ) |
| virtual

Definition at line 50 of file movieVideoCursor.cxx.

## Member Function Documentation

## ◆ apply_to_texture()

void MovieVideoCursor::apply_to_texture | ( | const Buffer * | buffer,
|  | Texture * | t,
|  | int | page )
| virtual

Stores this buffer's contents in the indicated texture.

Definition at line 120 of file movieVideoCursor.cxx.

References Texture::get_component_width, Texture::get_expected_ram_page_size, Texture::get_num_components, Texture::get_x_size, Texture::get_y_size, Texture::modify_ram_image(), and Texture::set_keep_ram_image.

## ◆ apply_to_texture_alpha()

void MovieVideoCursor::apply_to_texture_alpha | ( | const Buffer * | buffer,
|  | Texture * | t,
|  | int | page,
|  | int | alpha_src )
| virtual

Copies this buffer's contents into the alpha channel of the supplied texture.

The RGB channels of the texture are not touched.

Definition at line 181 of file movieVideoCursor.cxx.

References Texture::get_component_width, Texture::get_expected_ram_page_size, Texture::get_num_components, Texture::get_x_size, Texture::get_y_size, Texture::modify_ram_image(), and Texture::set_keep_ram_image.

## ◆ apply_to_texture_rgb()

void MovieVideoCursor::apply_to_texture_rgb | ( | const Buffer * | buffer,
|  | Texture * | t,
|  | int | page )
| virtual

Copies this buffer's contents into the RGB channels of the supplied texture.

The alpha channel of the texture is not touched.

Definition at line 248 of file movieVideoCursor.cxx.

References Texture::get_component_width, Texture::get_expected_ram_page_size, Texture::get_num_components, Texture::get_x_size, Texture::get_y_size, Texture::modify_ram_image(), and Texture::set_keep_ram_image.

## ◆ complete_pointers()

int MovieVideoCursor::complete_pointers | ( | TypedWritable ** | p_list,
|  | BamReader * | manager )
| virtual

Receives an array of pointers, one for each time manager->read_pointer() was called in fillin().

Returns the number of pointers processed.

Reimplemented from TypedWritable.

Definition at line 339 of file movieVideoCursor.cxx.

References TypedWritable::complete_pointers().

## ◆ force_init_type()

virtual TypeHandle MovieVideoCursor::force_init_type | ( |  | ) |
| inline virtual

Reimplemented from TypedWritableReferenceCount.

Definition at line 145 of file movieVideoCursor.h.

## ◆ get_class_type()

static TypeHandle MovieVideoCursor::get_class_type | ( |  | ) |
| inline static

Definition at line 133 of file movieVideoCursor.h.

## ◆ get_type()

virtual TypeHandle MovieVideoCursor::get_type | ( |  | ) | const
| inline virtual

Reimplemented from TypedWritableReferenceCount.

Definition at line 142 of file movieVideoCursor.h.

## ◆ init_type()

static void MovieVideoCursor::init_type | ( |  | ) |
| inline static

Definition at line 136 of file movieVideoCursor.h.

## ◆ set_time()

bool MovieVideoCursor::set_time | ( | double | timestamp,
|  | int | loop_count )
| virtual

Updates the cursor to the indicated time.

If loop_count >= 1, the time is clamped to the movie's length * loop_count. If loop_count <= 0, the time is understood to be modulo the movie's length.

Returns true if a new frame is now available, false otherwise. If this returns true, you should immediately follow this with exactly *one* call to fetch_buffer().

If the movie reports that it can_seek, you may also specify a time value less than the previous value you passed to set_time(). Otherwise, you may only specify a time value greater than or equal to the previous value.

If the movie reports that it can_seek, it doesn't mean that it can do so quickly. It may have to rewind the movie and then fast forward to the desired location. Only if can_seek_fast returns true can it seek rapidly.

Reimplemented in FfmpegVideoCursor, and InkblotVideoCursor.

Definition at line 99 of file movieVideoCursor.cxx.

## ◆ setup_texture()

void MovieVideoCursor::setup_texture | ( | Texture * | tex | ) | const

Set up the specified Texture object to contain content from this movie.

This should be called once, not every frame.

Definition at line 58 of file movieVideoCursor.cxx.

References Texture::adjust_this_size(), Texture::set_pad_size(), and Texture::setup_texture().

## ◆ write_datagram()

void MovieVideoCursor::write_datagram | ( | BamWriter * | manager,
|  | Datagram & | dg )
| virtual

Writes the contents of this object to the datagram for shipping out to a Bam file.

Reimplemented from TypedWritable.

Reimplemented in FfmpegVideoCursor.

Definition at line 328 of file movieVideoCursor.cxx.

References TypedWritable::write_datagram(), and BamWriter::write_pointer().

Referenced by FfmpegVideoCursor::write_datagram().

The documentation for this class was generated from the following files:

- panda/src/movies/movieVideoCursor.h
- panda/src/movies/movieVideoCursor.cxx